
#include <stdio.h>
#include "callback.h"

EVENT_FN g_EventCallbackFn; /* callback.h : typedef int (*EVENT_FN)(enum EVENT_k event, void *arg);  */

void RegisterCallback(EVENT_FN fn)
{
	g_EventCallbackFn = fn;
}


int Api_Event_SendEvent(enum EVENT_k event, void *arg)
{
	EVENT_FN fn = g_EventCallbackFn;

	if (fn)
		return (*fn)(event, arg);   /*calling user's function,, "callback" here */

	return 0;
}

void callback_func1()
{
	int det = 1;
	Api_Event_SendEvent(event_testcallback, (void *)&det);
	
	printf("callback1 is called\n");	
}

void callback_func2()
{
	int det = 2;
	Api_Event_SendEvent(event_testcallback2, (void *)&det);
	
	printf("callback2 is called\n");	
}

void callback_func3()
{
	int det = 3;
	Api_Event_SendEvent(event_testcallback3, (void *)&det);
	
	printf("callback3 is called\n");	
}

void MW_func()
{
	int i=0;
	while(i<15){
	
		if(i<5) callback_func1();
		
		else if(4< i && i<10) callback_func2();
		
		else if(9<i) callback_func3();
	i++;
	}
}


